//+----------------------------------------------------------------------------+
//|                                                          test_ErrorRU.mq4  |
//|                                                                            |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  14.04.2013      ErrorRU().                    |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link  "http://www.kimiv.ru"
#property show_inputs

extern int Error_Code = 130;

void start() {
  Message(ErrorRU(Error_Code, True));
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 14.04.2013                                                     |
//|   :       .         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    er -                                                           |
//|    po -    (False - , True - )          |
//+----------------------------------------------------------------------------+
string ErrorRU(int er, bool po=False) {
  string st;

  switch (er) {
    //  ,   
    case 0:
      st=" .";
      if (po) st=StringConcatenate(st, "\n", "   .");
      break;
    case 1:
      st=" ,   .";
      if (po) st=StringConcatenate(st, "\n", "OrderModify()   ",
                 "     .  ",
                 "       .");
      break;
    case 2:
      st=" .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "    .  ",
                 "     .");
      break;
    case 3:
      st=" .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "  , ,  ,",
                 "   ,  ",
                 "  ,     ..",
                 "    .");
      break;
    case 4:
      st="  .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "     (  ).");
      break;
    case 5:
      st="   .";
      if (po) st=StringConcatenate(st, "\n", "  ",
                 "   .");
      break;
    case 6:
      st="    .";
      if (po) st=StringConcatenate(st, "\n", " ,  ",
                 "   (,    IsConnected) ",
                 "     ( 5 )  .");
      break;
    case 7: st=" ."; break;
    case 8:
      st="  .";
      if (po) st=StringConcatenate(st, "\n", "  ",
                 " ,   .");
      break;
    case 9: st="    ."; break;
    case 64:
      st=" .";
      if (po) st=StringConcatenate(st, "\n", "     .");
      break;
    case 65:
      st="  .";
      if (po) st=StringConcatenate(st, "\n", "     .");
      break;
    case 128:
      st="    .";
      if (po) st=StringConcatenate(st, "\n", ",   ",
                 "  ( ,   1 ),  ,",
                 "       ( ",
                 "   ,       ",
                 " ,      ).");
      break;
    case 129:
      st="  Bid  Ask, ,  .";
      if (po) st=StringConcatenate(st, "\n", "    5",
                 "       RefreshRates()",
                 "   .    , ",
                 "         .");
      break;
    case 130:
      st=StringConcatenate("     ",
         "      (     ).");
      if (po) st=StringConcatenate(st, "\n", "    ",
                 "  ,    -  .",
                 "     5    ",
                 "   RefreshRates()   . ",
                 "   ,    ",
                 "      .");
      break;
    case 131:
      st=" ,    .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "      .");
      break;
    case 132:
      st=" .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "     (  ).");
      break;
    case 133:
      st=" .";
      if (po) st=StringConcatenate(st, "\n", "     .");
      break;
    case 134:
      st="    .";
      if (po) st=StringConcatenate(st, "\n", "    ",
                 "  .     ",
                 "  5 ,  ,     ",
                 "     .");
      break;
    case 135:
      st=" .";
      if (po) st=StringConcatenate(st, "\n", "    ",
                 "    RefreshRates()   .");
      break;
    case 136:
      st=" .";
      if (po) st=StringConcatenate(st, "\n", "  - ",
                 " (,     ,  ,",
                 "  )     .  ",
                 "   5      ",
                 " RefreshRates()   .");
      break;
    case 137: st=" ."; break;
    case 138:
      st="  ,   Bid  Ask.";
      if (po) st=StringConcatenate(st, "\n", "    ",
                 "    RefreshRates()   . ",
                 "   ,    ",
                 "      .");
      break;
    case 139:
      st="    .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "      .");
      break;
    case 140:
      st="  .";
      if (po) st=StringConcatenate(st, "\n", "  SELL .");
      break;
    case 141:
      st="  .";
      if (po) st=StringConcatenate(st, "\n", "  ",
                 " ,   .");
      break;
    case 142:
      st="   .";
      if (po) st=StringConcatenate(st, "\n", "  ,    ",
                 "      ",
                 " .        ,",
                 "        ",
                 "    .  ",
                 "      128.");
      break;
    case 143:
      st="    .";
      if (po) st=StringConcatenate(st, "\n", "    ",
                 "     .  ",
                 "    ,    142.  ",
                 "      128.");
      break;
    case 144:
      st="       .";
      if (po) st=StringConcatenate(st, "\n", "    ",
                 "     .");
      break;
    case 145:
      st=StringConcatenate(" ,     ",
         "     -   .");
      if (po) st=StringConcatenate(st, "\n", "  ,   15 ,",
                 "      RefreshRates()   .");
      break;
    case 146:
      st="  .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "  ,   IsTradeContextBusy()  FALSE.");
      break;
    case 147:
      st="     .";
      if (po) st=StringConcatenate(st, "\n", "    ",
                 "  ,    expiration.");
      break;
    case 148:
      st="      ,  .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "       ",
                 "     .");
      break;
    case 149:
      st=StringConcatenate("     ",
         "   ,   .");
      if (po) st=StringConcatenate(st, "\n", "  ",
                 "   ,   ",
                 "     ,    .");
      break;
    case 150:
      st="         FIFO.";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "      , ",
                 "       ,",
                 "    .");
      break;

    //    MQL4-
    case 4000: st=" ."; break;
    case 4001:
      st="  .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "     .");
      break;
    case 4002:
      st="  -  .";
      if (po) st=StringConcatenate(st, "\n", "   ,",
                 "      .");
      break;
    case 4003:
      st="    .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "       .");
      break;
    case 4004:
      st="    .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "   .");
      break;
    case 4005: st="      ."; break;
    case 4006:
      st="    .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "       ",
                 "   .");
      break;
    case 4007:
      st="    .";
      if (po) st=StringConcatenate(st, "\n", " ",
                 "      .");
      break;
    case 4008:
      st=" .";
      if (po) st=StringConcatenate(st, "\n", ",   -",
                 " ,    .");
      break;
    case 4009:
      st="   .";
      if (po) st=StringConcatenate(st, "\n", "  ,",
                 "   - ,    .");
      break;
    case 4010:
      st="    .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "      .");
      break;
    case 4011:
      st="  .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "        ",
                 " (     ).");
      break;
    case 4012:
      st="    .";
      if (po) st=StringConcatenate(st, "\n", "  0     .");
      break;
    case 4013: st="  .";             break;
    case 4014: st=" .";         break;
    case 4015: st=" .";        break;
    case 4016: st=" ."; break;
    case 4017:
      st=" DLL  .";
      if (po) st=StringConcatenate(st, "\n", "    DLL",
                 "  ,       DLL.");
      break;
    case 4018:
      st="  .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "    DLL  EX4-.");
      break;
    case 4019:
      st="  .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 " ,  DLL  EX4-    .");
      break;
    case 4020:
      st="     .";
      if (po) st=StringConcatenate(st, "\n", "  , ",
                 "  EX4- ,       EX4.");
      break;
    case 4021:
      st="   ,   .";
      if (po) st=StringConcatenate(st, "\n", " ",
                 "   ,   .");
      break;
    case 4022: st=" ."; break;
    case 4050:
      st="   .";
      if (po) st=StringConcatenate(st, "\n", "  ,",
                 "    .");
      break;
    case 4051: st="   ."; break;
    case 4052:
      st="   .";
      if (po) st=StringConcatenate(st, "\n", "    .");
      break;
    case 4053: st=" .";                               break;
    case 4054: st="  -."; break;
    case 4055: st="  .";          break;
    case 4056: st=" .";                         break;
    case 4057: st="   .";      break;
    case 4058: st="   .";          break;
    case 4059: st="     .";       break;
    case 4060:
      st="  .";
      if (po) st=StringConcatenate(st, "\n", "   ",
                 "  DLL .    \"\",  ",
                 "   .    \"\",",
                 "     .");
      break;
    case 4061: st="  .";                 break;
    case 4062: st="   string.";        break;
    case 4063: st="   integer.";       break;
    case 4064: st="   double.";        break;
    case 4065: st="    ."; break;
    case 4066: st="     ."; break;
    case 4067: st="    .";        break;
    case 4099: st=" .";                                    break;
    case 4100: st="    .";                     break;
    case 4101: st="  .";                         break;
    case 4102: st="   .";                  break;
    case 4103: st="  .";                        break;
    case 4104: st="    .";            break;
    case 4105: st="    .";                        break;
    case 4106: st=" .";                             break;
    case 4107: st="     "; break;
    case 4108: st="  .";                          break;
    case 4109:
      st="  .";
      if (po) st=StringConcatenate(st, "\n", "  ",
                 " \"  \"   .");
      break;
    case 4110:
      st="   .";
      if (po) st=StringConcatenate(st, "\n", "   .");
      break;
    case 4111:
      st="   .";
      if (po) st=StringConcatenate(st, "\n", "   .");
      break;
    case 4200: st="  .";                  break;
    case 4201: st="   ."; break;
    case 4202: st="  .";                   break;
    case 4203: st="  .";                break;
    case 4204: st="  .";                      break;
    case 4205: st="  .";               break;
    case 4206: st="   .";           break;
    case 4207: st="    .";           break;
    default:   st="unknown error";
  }
  return(st);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 08.03.2013                                                     |
//|   :   .                                    |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    ms -                                                      |
//|    nv -    :   (0-, 1-)              |
//|           Alert, Comment, Print, SendMail, SendNotification                |
//|    am -                                      |
//+----------------------------------------------------------------------------+
void Message(string ms, string nv="01100", bool am=False) {
  static string prevMessage="";
  string as[];
  int    i, k;

  if (StrToInteger(StringSubstr(nv, 1, 1))==1) Comment(ms);
  if ((StringLen(ms)>0) && (am || prevMessage!=ms)) {
    if (StrToInteger(StringSubstr(nv, 0, 1))==1) {
      k=StrSplit(ms, as, "\n");
      for (i=0; i<k; i++) Alert(as[i]);
    }
    if (StrToInteger(StringSubstr(nv, 2, 1))==1) {
      k=StrSplit(ms, as, "\n");
      for (i=0; i<k; i++) Print(as[i]);
    }
    if (StrToInteger(StringSubstr(nv, 3, 1))==1) SendMail(WindowExpertName(), ms);
    if (StrToInteger(StringSubstr(nv, 4, 1))==1) SendNotification(ms);
    prevMessage=ms;
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 20.01.2012                                                     |
//|   :                                |
//+----------------------------------------------------------------------------+
//|  :                                                                  |
//|                                                 |
//|  :                                                                |
//|    st -                                                |
//|    as -                                                     |
//|    de -                                                         |
//+----------------------------------------------------------------------------+
int StrSplit(string st, string& as[], string de=",") { 
  int    i=0, np;
  string stp;

  ArrayResize(as, 0);
  while (StringLen(st)>0) {
    np=StringFind(st, de);
    if (np<0) {
      stp=st;
      st="";
    } else {
      if (np==0) stp=""; else stp=StringSubstr(st, 0, np);
      st=StringSubstr(st, np+1);
    }
    i++;
    ArrayResize(as, i);
    as[i-1]=stp;
  }
  return(ArraySize(as));
}
//+----------------------------------------------------------------------------+

